﻿BetterMagnet = LibStub("AceAddon-3.0"):NewAddon("BetterMagnet", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("BetterMagnet")
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")

local defaults = {
	char = {
		["lootGold"] = true,
		["lootQuality"] = {
			[0] = true,
			[1] = false,
			[2] = true,
			[3] = true,
			[4] = false,
			[5] = false,
			[6] = false
		},

		["Armor"] = {
			["Cloth"] = true,
			["Cloth_BoU"] = true,
			["Cloth_BoE"] = true,
			["Cloth_BoP"] = false,
			["Leather"] = true,
			["Leather_BoU"] = true,
			["Leather_BoE"] = true,
			["Leather_BoP"] = false,
			["Mail"] = true,
			["Mail_BoU"] = true,
			["Mail_BoE"] = true,
			["Mail_BoP"] = false,
			["Plate"] = true,
			["Plate_BoU"] = true,
			["Plate_BoE"] = true,
			["Plate_BoP"] = false,
			
			["Idols"] = true,
			["Idols_BoU"] = true,
			["Idols_BoE"] = true,
			["Idols_BoP"] = false,
			["Librams"] = true,
			["Librams_BoU"] = true,
			["Librams_BoE"] = true,
			["Librams_BoP"] = false,
			["Shields"] = true,
			["Shields_BoU"] = true,
			["Shields_BoE"] = true,
			["Shields_BoP"] = false,
			["Totems"] = true,
			["Totems_BoU"] = true,
			["Totems_BoE"] = true,
			["Totems_BoP"] = false,
			["Sigils"] = true,
			["Sigils_BoU"] = true,
			["Sigils_BoE"] = true,
			["Sigils_BoP"] = false,
			["Miscellaneous"] = true,
			["Miscellaneous_BoU"] = true,
			["Miscellaneous_BoE"] = true,
			["Miscellaneous_BoP"] = false
		},
		["Consumable"] = {
			["Bandage"] = true,
			["Consumable"] = true,
			["Elixir"] = true,
			["Flask"] = true,

			["Food & Drink"] = true,
			["Item Enhancements"] = true,
			["Potion"] = true,
			["Scroll"] = true,
			["Other"] = true
		},
		["Containers"] = {
			["Bags"] = true,
			["Enchanting Bags"] = true,
			["Engineering Bags"] = true,
			["Gem Bags"] = true,

			["Herb Bags"] = true,
			["Inscription Bags"] = true,
			["Leatherworking Bags"] = true,
			["Mining Bags"] = true,
			["Soul Bags"] = true
		},
		["Currency"] = {
			["Currency"] = true
		},
		["Gem"] = {
			["Red Gems"] = true,
			["Blue Gems"] = true,
			["Yellow Gems"] = true,
			["Purple Gems"] = true,

			["Green Gems"] = true,
			["Orange Gems"] = true,
			["Meta Gems"] = true,
			["Simple Gems"] = true,
			["Prismatic Gems"] = true
		},
		["Key"] = {
			["Key"] = true
		},
		["Miscellaneous"] = {
			["Armor Tokens"] = true,
			["Holiday"] = true,
			["Junk"] = true,
			["Reagents"] = true,

			["Mounts"] = true,
			["Flying Mounts"] = true,
			["Combat Pets"] = true,
			["Small Pets"] = true,
			["Other"] = true
		},
		["Money"] = {
			["Money(OBSOLETE)"] = true
		},
		["Quivers"] = {
			["Quivers"] = true,
			["Ammo Puches"] = true
		},
		["Quest"] = {
			["Quest"] = true
		},
		["Projectiles"] = {
			["Arrows"] = true,
			["Bullets"] = true
		},
		["Recipes"] = {
			["Books"] = true,
			["Alchemy Recipes"] = true,
			["Blacksmithing Plans"] = true,
			["Cooking Recipes"] = true,

			["Enchanting Formulae"] = true,
			["Engineering Schematics"] = true,
			["First Aid Books"] = true,
			["Fishing Books"] = true,
			["Jewelcrafting Designs"] = true,
			["Leatherworking Patterns"] = true,
			["Tailoring Patterns"] = true
		},
		["Trade Goods"] = {
			["Armor Enchantment"] = true,
			["Cloth"] = true,
			["Device"] = true,
			["Elemental"] = true,

			["Enchanting"] = true,
			["Explosive"] = true,
			["Herb"] = true,
			["Jewelcrafting"] = true,
			["Leather"] = true,
			["Material"] = true,
			["Meat"] = true,
			["Metal & Stone"] = true,

			["Parts"] = true,
			["Weapon Enchantment"] = true,
			["Other"] = true
		},
		["Weapon"] = {
			["Daggers"] = true,
			["Fist Weapons"] = true,

			["One-Handed Axes"] = true,
			["One-Handed Maces"] = true,
			["One-Handed Swords"] = true,
			["Polearms"] = true,
			["Staves"] = true,
			["Two-Handed Axes"] = true,
			["Two-Handed Maces"] = true,
			["Two-Handed Swords"] = true,
			["Bows"] = true,

			["Crossbows"] = true,
			["Guns"] = true,
			["Thrown"] = true,
			["Wands"] = true,
			["Fishing Poles"] = true,
			["Miscellaneous"] = true
		},
		
		["items"] = {},
	},
}

local options = {
	type = "group",
	name = "BetterMagnet",
	args = {   
		config = {
			type = "execute",
			name = L["Open GUI"],
			desc = L["Opens the configuration panel"],
			guiHidden = true,
			func = function()
				InterfaceOptionsFrame:Hide()
				AceConfigDialog:SetDefaultSize("BetterMagnet", 620, 570)
				AceConfigDialog:Open("BetterMagnet")
			end
		},
		logo = {
			order = 1,
			type = "description",
			name = "",
			image = [[Interface\Addons\BetterMagnet\BetterMagnet]],
			imageWidth = 256,
			imageHeight = 128,
			imageCoords = { 0, 1, 0, 1 },
		},
		header = {
			order = 2,
			type = 'header',
			name = L["Autoloot options"],
		},
		add = {
			order = 3,
			type = 'input',
			name = L["Add item"],
			desc = L["Adds a new item to the autoloot list"],
			usage = "<item name>",
			get  = false,
			set  = function(info,v) BetterMagnet:Print("Adding "..string.lower(v)); BetterMagnet.db.char.items[string.lower(v)] = true end
		},
		del = {
			order = 4,
			type = 'input',
			name = L["Delete item"],
			desc = L["Deletes an item from the autoloot list"],
			usage = "<item name>",
			get  = false,
			set  = function(info,v) BetterMagnet:Print("Deleting "..string.lower(v)); BetterMagnet.db.char.items[string.lower(v)] = nil end
		},
		list = {
			order = 5,
			type = 'execute',
			name = L["Show item list"],
			desc = L["Shows the list of current items to search and autoloot for"],
			func = function() BetterMagnet:Print("Autoloot list:"); for i in pairs(BetterMagnet.db.char.items) do BetterMagnet:Print(i) end end
		},
		clear = {
			order = 6,
			type = 'execute',
			name = L["Clear item list"],
			desc = L["Will clear the list of current items to search and autoloot for. THIS IS NOT UNDOABLE."],
			func = function() BetterMagnet.db.char.items = {}; BetterMagnet:Print("Autoloot list cleared. It's empty now.") end
		},
		lootgold = {
			order = 7,
			type = 'toggle',
			name = L["Loot money"],
			desc = L["Automatically loot money too"],
			get = function() return BetterMagnet.db.char.lootGold end,
			set = function(info,v) BetterMagnet.db.char.lootGold = v end
		},
		lootQuality = {
			order = 8,
			type = "group",
			name = L["Loot by item quality"],
			desc = L["Loot items by their quality"],
			args = {
				["0"] = {
					order = 1,
					type = 'toggle',
					name = ITEM_QUALITY0_DESC,
					desc = L["Loot items with poor quality"],
					get = function(info) return BetterMagnet.db.char.lootQuality[0] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[0] = value end
				},
				["1"] = {
					order = 2,
					type = 'toggle',
					name = ITEM_QUALITY1_DESC,
					desc = L["Loot items with common quality"],
					get = function(info) return BetterMagnet.db.char.lootQuality[1] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[1] = value end
				},
				["2"] = {
					order = 3,
					type = 'toggle',
					name = ITEM_QUALITY2_DESC,
					desc = L["Loot items with uncommon quality"],
					get = function(info) return BetterMagnet.db.char.lootQuality[2] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[2] = value end
				},
				["3"] = {
					order = 4,
					type = 'toggle',
					name = ITEM_QUALITY3_DESC,
					desc = L["Loot items with rare quality"],
					get = function(info) return BetterMagnet.db.char.lootQuality[3] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[3] = value end
				},
				["4"] = {
					order = 5,
					type = 'toggle',
					name = ITEM_QUALITY4_DESC,
					desc = L["Loot items with epic quality"],
					get = function(info) return BetterMagnet.db.char.lootQuality[4] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[4] = value end
				},
				["5"] = {
					order = 6,
					type = 'toggle',
					name = ITEM_QUALITY5_DESC,
					desc = L["Loot items with legendary quality"],
					get = function(info) return BetterMagnet.db.char.lootQuality[5] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[5] = value end
				},
				["6"] = {
					order = 7,
					type = 'toggle',
					name = ITEM_QUALITY6_DESC,
					desc = L["Loot items with artifact quality"],
					get = function(info) return BetterMagnet.db.char.lootQuality[6] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[6] = value end
				},
			},
		},
		lootGoods = {
			order = 9,
			type = 'group',
			name = L["Loot Goods"],
			args = {
				Armor = {
					order = 1,
					type = 'group',
					name = ARMOR,
					args = {
						Cloth = {
							order =  1,
							type = 'group',
							inline = true,
							name = L["Cloth"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						Leather = {
							order =  2,
							type = 'group',
							inline = true,
							name = L["Leather"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						Mail = {
							order =  3,
							type = 'group',
							inline = true,
							name = L["Mail"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						Plate = {
							order =  4,
							type = 'group',
							inline = true,
							name = L["Plate"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						Idols = {
							order =  5,
							type = 'group',
							inline = true,
							name = L["Idols"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						Librams = {
							order =  6,
							type = 'group',
							inline = true,
							name = L["Librams"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						Shields = {
							order =  7,
							type = 'group',
							inline = true,
							name = L["Shields"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						Totems = {
							order =  8,
							type = 'group',
							inline = true,
							name = L["Totems"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						Sigils = {
							order =  9,
							type = 'group',
							inline = true,
							name = L["Sigils"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						Miscellaneous = {
							order =  10,
							type = 'group',
							inline = true,
							name = L["Miscellaneous"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
					},
				},
				Consumable = {
					order = 1,
					type = 'group',
					name = L["Consumable"],
					args = {
						Consumable = {
							order =  1,
							type = 'group',
							inline = true,
							name = L["General"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						['Food&Drink'] = {
							order =  2,
							type = 'group',
							inline = true,
							name = L["Food & Drink"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Food & Drink'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Food & Drink'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Food & Drink_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Food & Drink_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Food & Drink_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Food & Drink_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Food & Drink_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Food & Drink_BoP'] = value end,
								},
							},
						},
						Potion = {
							order =  3,
							type = 'group',
							inline = true,
							name = L["Potion"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						Elixir = {
							order =  4,
							type = 'group',
							inline = true,
							name = L["Elixir"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						Flask = {
							order =  5,
							type = 'group',
							inline = true,
							name = L["Flask"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						Bandage = {
							order =  6,
							type = 'group',
							inline = true,
							name = L["Bandage"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						ItemEnhancements = {
							order =  7,
							type = 'group',
							inline = true,
							name = L["Item Enhancements"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Item Enhancements'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Item Enhancements'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Item Enhancements_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Item Enhancements_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Item Enhancements_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Item Enhancements_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Item Enhancements_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Item Enhancements_BoP'] = value end,
								},
							},
						},
						Scroll = {
							order =  8,
							type = 'group',
							inline = true,
							name = L["Scroll"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
						Other = {
							order =  9,
							type = 'group',
							inline = true,
							name = L["Other"],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L["normal"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L["BoU"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoU"] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L["BoE"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoE"] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L["BoP"],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. "_BoP"] = value end,
								},
							},
						},
					},
				},
			},
		},
	},
}

AceConfig:RegisterOptionsTable("BetterMagnet", options, "BetterMagnet")

function BetterMagnet:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("BetterMagnetDB", defaults, "Default")
	AceConfigDialog:AddToBlizOptions("BetterMagnet", "BetterMagnet")
end

function BetterMagnet:OnEnable()
	self:RegisterEvent("LOOT_OPENED")
end

-- Ripped from Xloot
local tt = CreateFrame("GameTooltip", "BetterMagnetTooltip", UIParent, "GameTooltipTemplate")
local function GetBindOn(iLink)
	tt:SetOwner(UIParent, "ANCHOR_NONE")
	tt:SetHyperlink(iLink)
	if BetterMagnetTooltip:NumLines() > 1  and BetterMagnetTooltipTextLeft2:GetText() then
		local t = BetterMagnetTooltipTextLeft2:GetText()
		tt:Hide()
		if t == ITEM_BIND_ON_PICKUP then
			return "BoP"
		elseif t == ITEM_BIND_ON_EQUIP then
			return "BoE"
		elseif t == ITEM_BIND_ON_USE then
			return "BoU"
		end
	end
	tt:Hide()
end

function BetterMagnet:LOOT_OPENED()
	for i=1, GetNumLootItems() do
		if (LootSlotIsCoin(i) and self.db.char.lootGold) then
			LootSlot(i)
		elseif (LootSlotIsItem(i)) then
			local link = GetLootSlotLink(i)
			if not link then return end
			
			local itemName, _, itemRarity, _, _, iType, iSubtype = GetItemInfo(link)
			
			local bind = GetBindOn(link) or ""
			if (bind == "pickup" and itemRarity >= 3) then return end
			
			if (self.db.char.lootQuality[tostring(itemRarity)]) then
				LootSlot(i)
			elseif (self.db.char[iType][iSubtype .. bind]) then
				LootSlot(i)
			elseif (self.db.char.items[itemName]) then
				LootSlot(i)
			elseif (self.db.char[iType][iSubtype] == nil) then
				ChatFrame1:AddMessage(tostring(iType))
				ChatFrame1:AddMessage(tostring(iSubtype))
			end
		end
	end
end

function BetterMagnet:OnDisable()
	self:UnregisterEvent("LOOT_OPENED")
end
